package com.xhpc.user.mapper;

import com.xhpc.user.domain.XhpcCommunity;
import com.xhpc.user.domain.XhpcCommunityPersonnel;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Map;

public interface XhpcCommunityMapper {

    /**
     * 获取登陆用户信息
     */
    Map<String, Object> getLandUser(@Param("userId") Long userId);

    /**
     * 社区组树列表
     *
     * @param name         桩名称
     * @return
     */
    List<Map<String, Object>> list(@Param("name") String name,@Param("tenantId") String tenantId);

    /**
     * 社区组树列表
     *
     * @param name         桩名称
     * @return
     */
    List<Map<String, Object>> tree(@Param("name") String name,@Param("tenantId") String tenantId);

    /**
     * 添加社区组
     * @param xhpcCommunity
     * @return
     */
    int addCommunity(XhpcCommunity xhpcCommunity);

    /**
     * 修改社区组
     * @param xhpcCommunity
     * @return
     */
    int updateCommunity(XhpcCommunity xhpcCommunity);
    /**
     * 删除社区社区组
     * @param communityId
     */
    void deleteCommunity(@Param("communityId")Long communityId);

    /**
     * 检查改组是否还存在社区人员
     */
    int countCommunityPersonnel(@Param("communityId")Long communityId);


    /**
     * 查询社区组
     * @param communityId   社区id
     * @param name          名称
     * @param type          1 表示已社区id进行查询 2 排查社区id查询
     * @return
     */
    Map<String, Object> getCommunityById(@Param("communityId")Long communityId,@Param("name")String name,@Param("type")Integer type);


    List<Map<String, Object>> communityPersonnelTree(@Param("communityId")String communityId);

    /**
     * 社区人员列表
     * @return
     */
    List<Map<String, Object>> communityPersonnelList(@Param("communityId")Long communityId,@Param("account")String account,@Param("phone")String phone,@Param("status")Integer status);

    /**
     * 添加社区人员
     * @param xhpcCommunityPersonnel
     * @return
     */
    int addCommunityPersonnel(XhpcCommunityPersonnel xhpcCommunityPersonnel);

    /**
     * 查询社区人员
     * @return
     */
    Map<String, Object> getCommunityPersonnelById(@Param("communityPersonnelId")Long communityPersonnelId,@Param("phone")String phone,@Param("account")String account,@Param("type")Integer type);


    /**
     * 修改社区人员
     * @return
     */
    int updateCommunityPersonnel(XhpcCommunityPersonnel xhpcCommunityPersonnel);

    /**
     * 删除社区社人员
     * @param communityPersonnelId
     */
    void deleteCommunityPersonnel(@Param("communityPersonnelId")Long communityPersonnelId);

    /**
     * 社区人员状态改变
     */
    void updateCommunityPersonnelStatus(@Param("communityPersonnelId")Long communityPersonnelId,@Param("status")Integer status);


    /**
     * 根据用户id获取社区组
     */
    Map<String, Object> getCommunityPersonnelUserId(@Param("userId")Long userId,@Param("tenantId")String tenantId,@Param("chargingStationId")Long chargingStationId);
}
